# cin_seff

1. [Description](#description)
1. [Examples](examples)
2. [Known Issue](#known-issue)
3. [Credits](#credits)

## Description
CINECA version of Slurm job EFFiciency report (seff).

`cin_seff` takes a list of jobids and reports on the efficiency of their cpu and memory utilization. 

## Examples:

```bash
$ python3 cin_seff -h
usage: cin_seff [-h] -j JOBIDS [--json] [-v VERBOSITY]

This command provides statistics on the efficiency of resource utilization for
completed jobs.

optional arguments:
  -h, --help            show this help message and exit
  --json                Set output format to JSON.
  -v VERBOSITY, --verbosity VERBOSITY
                        Set program verbosity. Used for debugging and testing.

required named arguments:
  -j JOBIDS, --jobids JOBIDS
                        ID of the completed job.
```

```bash
$ python3 cin_seff -j 863428[0-2]

Job ID:              8634280
User:                <user_X>
Account:             <account_X>
Partition:           boost_usr_prod
QOS:                 normal
State:               CANCELLED by 33678 (exit code 0:0)
Nodes:               0
Job Wall-clock time: 00:00:00

Job ID:              8634281
User:                <user_Y>
Account:             <account_Y>
Partition:           boost_usr_prod
QOS:                 normal
State:               COMPLETED (exit code 0:0)
Nodes:               20
Job Wall-clock time: 00:19:49
Memory Utilized: 235.4144630432129 GiB
Memory Efficiency: 19.57% of 1203.125 GiB


Job ID:              8634282
User:                <user_Z>
Account:             <account_Z>
Partition:           boost_usr_prod
QOS:                 normal
State:               COMPLETED (exit code 0:0)
Nodes:               20
Job Wall-clock time: 00:19:55
Memory Utilized: 235.4281005859375 GiB
Memory Efficiency: 19.57% of 1203.125 GiB
```

## Known Issue
Jobs executed in exclusive mode, where the requested resources less than the total available on the node, may incorrectly report memory efficiency. For example, job 8754360 requested 15,400MB of memory but used 139,841,548KB, leading to a reported memory efficiency of 886.78%.


## Credits
Based on [seff](https://github.com/SchedMD/slurm/blob/master/contribs/seff/seff) command, developed by Princeton University Research Computing.
